var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { expect } from "chai";
import { attr, AttributeDefinition } from "./attributes.js";
import { FASTElement } from "./fast-element.js";
describe("Attributes", () => {
    it("should be properly aggregated across an inheritance hierarchy.", () => {
        class BaseElement extends FASTElement {
            constructor() {
                super(...arguments);
                this.attributeOne = "";
            }
        }
        __decorate([
            attr,
            __metadata("design:type", Object)
        ], BaseElement.prototype, "attributeOne", void 0);
        class ComponentA extends BaseElement {
            constructor() {
                super(...arguments);
                this.attributeTwo = "two-A";
            }
        }
        __decorate([
            attr,
            __metadata("design:type", Object)
        ], ComponentA.prototype, "attributeTwo", void 0);
        class ComponentB extends BaseElement {
            get attributeTwo() {
                return "two-B";
            }
        }
        const componentAAtributes = AttributeDefinition.collect(ComponentA);
        const componentBAtributes = AttributeDefinition.collect(ComponentB);
        expect(componentAAtributes.length).equal(2);
        expect(componentBAtributes.length).equal(1);
    });
});
